/***********************************************************************************************/
/************************************** command.c **********************************************/
/***********************************************************************************************/

#define __COMMAND
#include "command.h"

/***********************************************************************************************/
/***************************** check for messages to control thread ****************************/
/***********************************************************************************************/
void get_control_messages(){

   int i;

	if((emsg = GetMsg(TO_CONTROL_MSG)) != EMPTY){
		switch(emsg){
			case RELEASE_RECORDING:  
				Wait_for_RecordThread = FALSE;
			break;
			case INCREASE_PARAMETER:
            increase_parameter();
			break;
			case DECREASE_PARAMETER:
            decrease_parameter();
			break;
			case INCREASE_FIELD:
            FIELD_TO_ADJUST += 1;
            if (FIELD_TO_ADJUST >= FIELD_MAX) FIELD_TO_ADJUST = 0;
			break;
			case DECREASE_FIELD:
            if (FIELD_TO_ADJUST <= 0) FIELD_TO_ADJUST = FIELD_MAX - 1;
            else FIELD_TO_ADJUST -= 1;
         break;
         case ENTER_TEST_MODE:
            if (main_status != TEST_MODE){
               main_status = TEST_MODE;
               PrintErrorMsg("Entering test code");
               enable(AXIS_01_DIO_ENB | AXIS_02_DIO_ENB);  //turn on the appropriate amps
               // could also set desired velocity or torque here
            }
            else{
               main_status = WAITING;
       			zero_outputs();    
               PrintErrorMsg("Leaving test code"); 
               enable(0x00);  //turn off all amps
            }          
         default:
			break;
		}
	}

}
/***********************************************************************************************/
/********************************* logic flow of control program *******************************/
/***********************************************************************************************/
void control_status_switch_structure(){

   int i;

	switch (main_status)	{
		case HEARTBEAT_1:
   		read_sensors();
			zero_outputs();
			enable(0x00); /* turn off all motor amplifiers */
			main_status = WAITING;
		break;
		case FAULT:
			read_sensors();
			zero_outputs();
         // take some action if you want
		break;
		case WAITING:
			read_sensors();
         zero_outputs();
		break;
		case TEST_MODE:
			read_sensors();
         interpret_sensor_data();
			compute_outputs();
		break;			
		default:
			read_sensors();
			zero_outputs();
		break;
	}

}

/***********************************************************************************************/
/********************** increase parameter when prompted ***************************************/
/***********************************************************************************************/
void increase_parameter(){

   int i;

   switch (FIELD_TO_ADJUST){
      case ADJ_P_GAIN:
         axis_01_p_gain += P_GAIN_INCREMENT;
      break;
      case ADJ_I_GAIN:
         axis_01_i_gain += I_GAIN_INCREMENT;
      break;
      case ADJ_D_GAIN:
         axis_01_d_gain += D_GAIN_INCREMENT;
      break;
      default:
      break;
   }

}

/***********************************************************************************************/
/************************ decrease parameter when prompted *************************************/
/***********************************************************************************************/
void decrease_parameter(){

   int i;

   switch (FIELD_TO_ADJUST){
      case ADJ_P_GAIN:
         axis_01_p_gain -= P_GAIN_INCREMENT;
      break;
      case ADJ_I_GAIN:
         axis_01_i_gain -= I_GAIN_INCREMENT;
      break;
      case ADJ_D_GAIN:
         axis_01_d_gain -= D_GAIN_INCREMENT;
      break;
      default:
      break;
   }

}