/***********************************************************************************************/
/*************************************** command.h *********************************************/
/***********************************************************************************************/

#ifndef COMMAND_H
#define COMMAND_H

/***********************************************************************************************/
/************************************ Standard Headers *****************************************/
/***********************************************************************************************/
#include <stdint.h>
/***********************************************************************************************/
/************************************ My Headers ***********************************************/
/***********************************************************************************************/
#ifdef __COMMAND
#include "gui.h"
#include "queue.h"
#include "control.h"
#include "logging.h"
#include "ericmath.h"
#include "mydefines.h"		/* data types */
#endif

/* status bits for "MAIN_STATUS" */
#define HEARTBEAT_1					0x00
#define WAITING						0x01
#define TEST_MODE						0x02
#define FAULT							0x03

/* fields that have adjustable parameters */
#define ADJ_P_GAIN               0x00
#define ADJ_I_GAIN               0x01
#define ADJ_D_GAIN               0x02
#define FIELD_MAX        	      0x03

void get_control_messages();
void control_status_switch_structure();
void increase_parameter();
void decrease_parameter();

#ifdef __MAIN
#define EXTERN
int terminate_data = FALSE;					/* terminate for the data logging thread */
int terminate_gui = FALSE;						/* terminate for the gui thread */
unsigned char main_status = HEARTBEAT_1;	/* control thread status flag */
unsigned long beat = 0;							/* 64 bit counter incremented each DT by the function "heartbeat()" */
#else
#define EXTERN extern
extern int terminate_data;
extern int terminate_gui;
extern unsigned char main_status;
extern unsigned long beat;
#endif

EXTERN	uint64_t start;
EXTERN	uint64_t stop;
EXTERN	uint64_t elapsed;
EXTERN	uint64_t sample_time;
EXTERN	uint64_t old_start;
EXTERN   unsigned int FIELD_TO_ADJUST;             /* used for online adjustment of unilateral parameters */
EXTERN	double DT;											/* approximation to 1/InterruptFrequency */
EXTERN	double DT_INV;										/* equal to InterruptFrequency */

#endif // end of COMMAND_H