/***********************************************************************************************/
/*************************************** logging.h *********************************************/
/***********************************************************************************************/

#ifndef LOGGING_H
#define LOGGING_H

/***********************************************************************************************/
/************************************ Standard Headers *****************************************/
/***********************************************************************************************/
#include <semaphore.h>

/***********************************************************************************************/
/************************************ My Headers ***********************************************/
/***********************************************************************************************/
#ifdef __LOGGING
#include "gui.h"
#include "queue.h"
#include "command.h"				/* for "MAIN_STATUS" and "DT", etc. */
#include "mydefines.h"
#include "control.h"
#endif

void buffer_data();
void write_buffer();
void stop_data_thread();
long filesize(FILE*);

#define RECORD_SIZE 1*2*3*4*5*6*7			/* in number of 'floats': MAKE SURE this is an integer multiple of the number of measurements you are taking!!!! */
#define FILE_IO_PERIOD   1 	            /* data decimation period, "1" means you record data every timestep, "10" every tenth timestep */

#define NUMBER_OF_RECORDS 20					/* number of records to keep in memory - you don't need to change this */

#ifdef __MAIN
#define EXTERN
int data_cache_sub_index = 0;
int Data_Cache_Index_In = 0;					/* data cache coordinating index */
int Data_Cache_Index_Out = 0;					/* data cache coordinating index, gui has access to this for display */
int recording = FALSE;							/* log data when set to true */
int Wait_for_RecordThread = TRUE;			/* keep data thread alive if true */
#else
#define EXTERN extern
extern int data_cache_sub_index;
extern int Data_Cache_Index_In;
extern int Data_Cache_Index_Out;
extern int recording;
extern int Wait_for_RecordThread;
#endif

EXTERN float *Data_Cache;								/* pointer to the main data cache */
EXTERN sem_t Data_Cache_Sem;							/* semaphore for data cache */
EXTERN int data_semval;											/* data recording semaphore */
EXTERN char filesizestr[20];							/* so gui has access to this for display */
EXTERN char filestr[40];									/* so gui has access to this for display */

#endif // end of LOGGING_H