/***********************************************************************************************/
/*********************************** mydefines.h ***********************************************/
/***********************************************************************************************/

#ifndef DEFINES_H 
#define DEFINES_H 

/***********************************************************************************************/
/************************************ Standard Headers *****************************************/
/***********************************************************************************************/
#ifdef __MAIN
#include <stdio.h>
#include <iostream.h>
#include <curses.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <math.h>
#include <time.h>
#include <inttypes.h>
#include <string.h>
#include <errno.h>
#include <syslog.h>
#include <process.h>
#include <stddef.h>
#include <signal.h>
#include <sys/sched.h>
#include <sys/mman.h>
#include <sys/neutrino.h>
#include <pthread.h>
#include <sys/netmgr.h>
#include <sys/syspage.h>
#include <sys/siginfo.h>
#include <hw/inout.h>
#include <semaphore.h>
#include <hw/pci.h>
#include <sys/uio.h>
#include <malloc.h>
#include <malloc_g/malloc.h>
#include <malloc_g/malloc-lib.h>
#endif

/***********************************************************************************************/
/************************************ My Headers ***********************************************/
/***********************************************************************************************/
#ifdef __MAIN
#include "servotogo.h"
#include "ericmath.h"
#include "queue.h"
#include "control.h"
#include "filter.h"
#include "gui.h"
#include "command.h"
#include "logging.h"
#endif

/***********************************************************************************************/
/********************************* Function Prototypes *****************************************/
/***********************************************************************************************/
#ifdef __MAIN
void *startControlThread(void *);
void *startDataThread(void *);
void *startGuiThread(void *);
void quitprogram();
#endif

/* used to set up servo-to-go timers */
#define INT_FREQ						2000					// desired interrupt frequency in Hz

#endif // end of DEFINES_H 
